#ifndef __PROMISE_HPP__
#define __PROMISE_HPP__


#include <type_traits>

#include <result.hpp>


namespace typon
{

  template <typename T>
  struct promise
  {
    result<T>* _result;

    template <typename U>
    void return_value(U&& expr) noexcept(std::is_nothrow_constructible_v<T, U&&>)
    {
      _result->return_value(std::forward<U>(expr));
    }

    void unhandled_exception() noexcept
    {
      _result->unhandled_exception();
    }
  };


  template <>
  struct promise<void>
  {
    result<void>* _result;

    void return_void() noexcept {}

    void unhandled_exception() noexcept
    {
      _result->unhandled_exception();
    }
  };

}

#endif // __PROMISE_HPP__
